#include <Application.h>
#include <Button.h>
#include <GroupLayoutBuilder.h>
#include <LayoutBuilder.h>
#include <RadioButton.h>
#include <TextControl.h>
#include <View.h>
#include <Window.h>

#include <cstdio>
#include <cstdlib>


enum messages {
	kButtonMessage
};

class Window : public BWindow {
public:
	Window();
	virtual void MessageReceived(BMessage* message);
private:
	BButton* fButton;
	BTextControl* fTextControl;
};

int main()
{
	BApplication app("application/bitmaptest");
	
	Window* window = new Window();
	window->Show();
	app.Run();
	return 0;
}	


// Window
Window::Window()
	:
	BWindow(BRect(100, 100, 400, 400), "window", B_TITLED_WINDOW, B_NOT_RESIZABLE|B_NOT_ZOOMABLE|B_AUTO_UPDATE_SIZE_LIMITS|B_QUIT_ON_WINDOW_CLOSE)
{
	fButton = new BButton("button", new BMessage(kButtonMessage));
	fTextControl = new BTextControl("textcontrol", "control", new BMessage());
	BLayoutBuilder::Group<>(this, B_HORIZONTAL)
		.Add(fButton)
		.Add(fTextControl)
	.End();
}


void
Window::MessageReceived(BMessage* message)
{
	switch (message->what) {
		case kButtonMessage:
		{
			fTextControl->SetEnabled(!fTextControl->IsEnabled());
			break;
		}
		default:
			BWindow::MessageReceived(message);
			break;
	}
}
