#include <Application.h>
#include <Window.h>
#include <TextView.h>
#include <String.h>
#include <LayoutBuilder.h>

class AppTest : public BApplication {
public:
  AppTest()
    :BApplication("application/x-vnd.badtv")
    {
      BString text;
      text.Append('m', 200);

      BWindow* win1 = new BWindow(BRect(100, 200, 400, 500), "No Layout, non-editable", B_TITLED_WINDOW, B_QUIT_ON_WINDOW_CLOSE);
      BTextView* tv1 = new BTextView("");
      tv1->ResizeTo(250, 250);
      tv1->MakeEditable(false);
      tv1->SetText(text);
      tv1->SetInsets(20, 30, 40, 50);
      win1->AddChild(tv1);
      win1->Show();

      BWindow* win2 = new BWindow(BRect(100, 200, 400, 500), "Layout, editable", B_TITLED_WINDOW, B_QUIT_ON_WINDOW_CLOSE);
      win2->MoveBy(200, 50);
      BTextView* tv2 = new BTextView("");
      tv2->SetText(text);
      tv2->SetInsets(20, 30, 40, 50);
      BLayoutBuilder::Group<>(win2, B_VERTICAL)
          //.SetInsets(0)
          .Add(tv2);
      win2->Show();


      BWindow* win3 = new BWindow(BRect(100, 200, 400, 500), "Layout, non-editable", B_TITLED_WINDOW, B_QUIT_ON_WINDOW_CLOSE);
      win3->MoveBy(400, 100);
      BTextView* tv3 = new BTextView("");
      tv3->SetText(text);
      tv3->SetInsets(20, 30, 40, 50);
      tv3->MakeEditable(false);
      BLayoutBuilder::Group<>(win3, B_VERTICAL)
          //.SetInsets(0)
          .Add(tv3);
      win3->Show();
    }
};


int main(int argc, char* argv[]) {
  AppTest* app = new AppTest();
  app->Run();
}
